local blizzFrames = {}
for frameName in pairs(UIPanelWindows) do
	local frame = _G[frameName]
	if frame and frame:IsMovable() and not frame:IsProtected() then
		blizzFrames[frame] = true
	end
end

local module = Dock:NewModule("Blizzard Frames", "AceEvent-3.0")

function module:OnInitialize()
	self:RegisterMessage("Dock_FrameDocked")
	self:RegisterMessage("Dock_FrameReleased")
	self:RegisterMessage("Dock_FrameRestored")
	self:RegisterMessage("Dock_FrameSentToDock", "Dock_FrameDocked")
end

local function IsShown()
	return true
end
local minimapClamp
function module:Dock_FrameDocked(event, frame, dock)
	if blizzFrames[frame] then
		local oldIsShown = frame.IsShown
		frame.IsShown = IsShown
		HideUIPanel(frame)
		frame.IsShown = oldIsShown
		frame:SetAttribute("UIPanelLayout-enabled", nil)
		frame:Show()
	elseif frame == MinimapCluster then
		minimapClamp = Minimap:IsClampedToScreen()
		Minimap:SetClampedToScreen(false)
	end
end

function module:Dock_FrameReleased(event, frame, dock)
	if blizzFrames[frame] then
		local wasShown = frame:IsShown()
		frame:Hide()
		frame:SetAttribute("UIPanelLayout-enabled", true)
		if wasShown then
			ShowUIPanel(frame)
		end
	elseif frame == MinimapCluster then
		Minimap:SetClampedToScreen(minimapClamp)
	end
end

function module:Dock_FrameRestored(event, frame, dock)
	if blizzFrames[frame] then
		local wasShown = frame:IsShown()
		HideUIPanel(frame)
		if wasShown then
			ShowUIPanel(frame)
		end
	end
end